import { StiChangesInterceptor } from "../system/interfaces";
import StiJson from "../system/StiJson";
export default class StiRectangleGeometry {
    static DELTA: number;
    private _x;
    private _y;
    private _width;
    private _height;
    _minWidth: number;
    _minHeight: number;
    _maxWidth: number;
    _maxHeight: number;
    changesInterceptor: StiChangesInterceptor;
    private savedGeometry;
    isChanged(): boolean;
    resetChanged(): void;
    saveToJsonObject(options: any): StiJson;
    equals(geometry: StiRectangleGeometry): boolean;
    loadFromJsonObject(json: StiJson): void;
    clone(): StiRectangleGeometry;
    get x(): number;
    set x(value: number);
    get y(): number;
    set y(value: number);
    get width(): number;
    set width(value: number);
    get height(): number;
    set height(value: number);
    get minWidth(): number;
    set minWidth(value: number);
    get minHeight(): number;
    set minHeight(value: number);
    get right(): number;
    get bottom(): number;
    get centerX(): number;
    get centerY(): number;
    constructor(width?: number, height?: number, changesInterceptor?: StiChangesInterceptor);
    withY(newY: number): StiRectangleGeometry;
    xProjectionIntersectsWith(other: StiRectangleGeometry): boolean;
    intersectWith(geometry: StiRectangleGeometry): boolean;
}
